	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	znaky.inc
	#include	displej.inc
	#include	pameti.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

#DEFINE	DB4	PORTE,2		; PINY PRO OVLADANI DISPLEJE
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

OFFRAM	EQU	H'20'		; ZACATEK VOLNE PAMETI "RAM"

	CBLOCK	OFFRAM
	TMH:1
	TML:1
	DDATA:1

	XDATA:2
	XADRESA:2

	CITAC:1
	ENDC

	ORG	0
	NOP
	NOP
	NOP

	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA jako "logicky"
	MOVWF	ADCON1
	banksel	0

	CALL	INITDISP

	CLRF	XADRESA	; do FLASH pameti se uklada napis i s pozicemi znaku
	MOVLW	D'8'
	MOVWF	XADRESA+1
	MOVLW	ZNAK_T
	MOVWF	XDATA
	MOVLW	D'3'
	MOVWF	XDATA+1
	CALL	FWRITE

	INCF	XADRESA,F
	MOVLW	ZNAK_E
	MOVWF	XDATA
	INCF	XDATA+1,F
	CALL	FWRITE

	INCF	XADRESA,F
	MOVLW	ZNAK_S
	MOVWF	XDATA
	INCF	XDATA+1,F
	CALL	FWRITE

	INCF	XADRESA,F
	MOVLW	ZNAK_T
	MOVWF	XDATA
	INCF	XDATA+1,F
	CALL	FWRITE

	INCF	XADRESA,F
	MOVLW	ZNAK_SP
	MOVWF	XDATA
	INCF	XDATA+1,F
	CALL	FWRITE

	INCF	XADRESA,F
	MOVLW	ZNAK_F
	MOVWF	XDATA
	INCF	XDATA+1,F
	CALL	FWRITE

	INCF	XADRESA,F
	MOVLW	ZNAK_L
	MOVWF	XDATA
	INCF	XDATA+1,F
	CALL	FWRITE

	INCF	XADRESA,F
	MOVLW	ZNAK_A
	MOVWF	XDATA
	INCF	XDATA+1,F
	CALL	FWRITE

	INCF	XADRESA,F
	MOVLW	ZNAK_S
	MOVWF	XDATA
	INCF	XDATA+1,F
	CALL	FWRITE

	INCF	XADRESA,F
	MOVLW	ZNAK_H
	MOVWF	XDATA
	INCF	XDATA+1,F
	CALL	FWRITE

	MOVLW	D'10'
	MOVWF	CITAC
LOOP1	DECF	CITAC,W	; napis je cten z FLASH pameti a zobrazovan na displeji
	MOVWF	XADRESA
	CALL	FREAD
	MOVF	XDATA+1,W
	CALL	SETPOS
	MOVF	XDATA,W
	CALL	PUTZNAK
	DECFSZ	CITAC,F
	GOTO	LOOP1
	
LOOP2	GOTO	LOOP2

	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS
	
FWRITE	FWRITE_	XDATA,XADRESA,0,1
	RETURN

FREAD	FREAD_	XDATA,XADRESA
	RETURN

	END
